// RtdxEventsSink.cpp : implementation file
//

#include "stdafx.h"
#include "MFCCatchRTDXEvents.h"
#include "RtdxEventsSink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRtdxEventsSink

IMPLEMENT_DYNCREATE(CRtdxEventsSink, CCmdTarget)

CRtdxEventsSink::CRtdxEventsSink()
{
	EnableAutomation();
}

CRtdxEventsSink::~CRtdxEventsSink()
{
}


void CRtdxEventsSink::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CRtdxEventsSink, CCmdTarget)
	//{{AFX_MSG_MAP(CRtdxEventsSink)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CRtdxEventsSink, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CRtdxEventsSink)
	DISP_FUNCTION(CRtdxEventsSink, "OnChannelOpen", OnChannelOpen, VT_EMPTY, VTS_PVARIANT VTS_I4)
	DISP_FUNCTION(CRtdxEventsSink, "OnChannelClose", OnChannelClose, VT_EMPTY, VTS_PVARIANT VTS_I4)
	DISP_FUNCTION(CRtdxEventsSink, "OnChannelEnabled", OnChannelEnabled, VT_EMPTY, VTS_PVARIANT VTS_I4)
	DISP_FUNCTION(CRtdxEventsSink, "OnChannelDisabled", OnChannelDisabled, VT_EMPTY, VTS_PVARIANT VTS_I4)
	DISP_FUNCTION(CRtdxEventsSink, "OnRtdxEnabled", OnRtdxEnabled, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CRtdxEventsSink, "OnRtdxDisabled", OnRtdxDisabled, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CRtdxEventsSink, "OnRtdxConfigured", OnRtdxConfigured, VT_EMPTY, VTS_I4)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IRtdxEventsSink to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

static const IID IID_IRtdxEventsSink = __uuidof(CodeComposer::IRtdxEvents);


BEGIN_INTERFACE_MAP(CRtdxEventsSink, CCmdTarget)
	INTERFACE_PART(CRtdxEventsSink, IID_IRtdxEventsSink, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRtdxEventsSink message handlers

void CRtdxEventsSink::OnChannelOpen(VARIANT FAR* pVariant, long ResultCode) 
{
	::MessageBox(NULL,
				_T("CodeComposer fired an RTDX OnChannelOpen event"),
				_T("MFCCatchRtdxEvents"),
				MB_OK);
}

void CRtdxEventsSink::OnChannelClose(VARIANT FAR* pVariant, long ResultCode) 
{
	::MessageBox(NULL,
				_T("CodeComposer fired an RTDX OnChannelClose event"),
				_T("MFCCatchRtdxEvents"),
				MB_OK);
}

void CRtdxEventsSink::OnChannelEnabled(VARIANT FAR* pVariant, long ResultCode) 
{
	::MessageBox(NULL,
				_T("CodeComposer fired an RTDX OnChannelEnabled event"),
				_T("MFCCatchRtdxEvents"),
				MB_OK);
}

void CRtdxEventsSink::OnChannelDisabled(VARIANT FAR* pVariant, long ResultCode) 
{
	::MessageBox(NULL,
				_T("CodeComposer fired an RTDX OnChannelDisabled event"),
				_T("MFCCatchRtdxEvents"),
				MB_OK);
}

void CRtdxEventsSink::OnRtdxEnabled(long ResultCode) 
{
	::MessageBox(NULL,
				_T("CodeComposer fired an RTDX OnRtdxEnabled event"),
				_T("MFCCatchRtdxEvents"),
				MB_OK);
}

void CRtdxEventsSink::OnRtdxDisabled(long ResultCode) 
{
	::MessageBox(NULL,
				_T("CodeComposer fired an RTDX OnRtdxDisabled event"),
				_T("MFCCatchRtdxEvents"),
				MB_OK);
}

void CRtdxEventsSink::OnRtdxConfigured(long ResultCode) 
{
	::MessageBox(NULL,
				_T("CodeComposer fired an RTDX OnRtdxConfigured event"),
				_T("MFCCatchRtdxEvents"),
				MB_OK);
}
