                ++++++++++++++++++++++++++++++++++++++++++++++
                ++++++++++++++++++++++++++++++++++++++++++++++
                       XDS510PP USAGE AND INSTALLATION
                ++++++++++++++++++++++++++++++++++++++++++++++
                ++++++++++++++++++++++++++++++++++++++++++++++

HW Install
==========

See the new XDS51X Installation Guide.  

OR

   1. Plug the parallel port cable into the back of your PC.
   2. Connect the parallel port cable to the XDS510PP.
   3. Connect the 14 pin cable into the XDS. You do not have to supply
      power to the XDS510PP via the external power connection because
      it draws power from the XDS or programmer. Note that the ACTIVE 
      light on the pod only goes on when the emulator software is 
      running, not when power is on (so don't panic because the light 
      is not on).

SW Install
==========

*** It is STRONGLY recommended that you perform steps 1. and 2. below
*** to ensure the highest performance from the XDS510PP.

1.  Check your BIOS to see what parallel port setup you have.  You should
    select one of the following modes:

        4-bit unidirectional mode
        8-bit bidirectional mode
        EPP, Enhanced Parallel Port 

     EPP mode is the recommended choice and provides the best
     performance. If your BIOS offers the option "EPP+ECP" and
     "EPP+SPP" then select "EPP+SPP".  The "EPP+ECP" option is not
     supported.

     If all this is confusing then just leave the default mode for now.

     Run the PORTCHK utility (supplied with your XDS software) to check
     the address of your parallel port (The default is usually 378.
     This information can also be found in your BIOS setup). Record the
     parallel port address as you will need it in step 2 below. You can
     also run the supplied SMCMODE utility to gather additional
     information about the setup of your parallel port.

2.  Create a file named XDS510PP.INI if it does not exist (one is
    supplied on the disk with your XDS software).  In this file you
    will need to setup the parallel port address, mode, and optional
    speed parameters. Following is an example:

	port  = 378   
	mode  = EPP
	speed = 10  
       
     Where:

	port       is the I/O address of your parallel port.  Address
        	   378 is generally the default.

        mode       is the parallel port mode.  Enter one of the
        	   following:
        	   
                       SPP4   4-bit unidirectional mode
                       SPP8   8-bit bidirectional mode
                       EPP    Enhanced parallel Port   

        speed       is a delay parameter that may be required on some
        	    systems. It is recommended that you set this to 10
        	    initially.  Once you get your XDS510PP up and
        	    running you can reduce this number or delete the
        	    parameter entirely and see if your system still
        	    works.

Note: XDS510PP.INI goes in the directory you run the debugger from.

3.   Setup the XDS510PP DLL by copying the file SMG510.PP to
     SMG510W.DLL.
     
     Your XDS debugger software or programmer software will work with
     either the XDS510 or the the XDS510PP.  When the XDS software is
     invoked it looks for the DLL file SMG510W.DLL.  Your product is
     supplied with a DLL file for the XDS510 (SMG510.XDS) and
     XDS510PP (SMG510.PP). There are two programmer executables, one
     for the XDS510 (PRGP16W.EXE) and one for the XDS510PP (PRGP16WP.EXE).

4.   Install your debugger and programmer icons etc. as usual and
     invoke the software.

